<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: FTPServer.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">FTPServer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * FTPServer.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: May 6, 2018</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NETWORKING_FTPSERVER_FTPSERVER_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define NETWORKING_FTPSERVER_FTPSERVER_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;sstream&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;fstream&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &lt;exception&gt;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="classFTPCallbacks.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFTPCallbacks.html">FTPCallbacks</a> {</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span>        <a class="code" href="classFTPCallbacks.html#a310e8643ffeec67b4049423c44ba1b23">onStoreStart</a>(std::string fileName);</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">size_t</span>      onStoreData(uint8_t* data, <span class="keywordtype">size_t</span> size);</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span>        onStoreEnd();</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span>        onRetrieveStart(std::string fileName);</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">size_t</span>      onRetrieveData(uint8_t *data, <span class="keywordtype">size_t</span> size);</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keyword">virtual</span> <span class="keywordtype">void</span>        onRetrieveEnd();</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keyword">virtual</span> std::string onDir();</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classFTPCallbacks.html">FTPCallbacks</a>();</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;};</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classFTPFileCallbacks.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFTPFileCallbacks.html">FTPFileCallbacks</a> : <span class="keyword">public</span> <a class="code" href="classFTPCallbacks.html">FTPCallbacks</a> {</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classFTPFileCallbacks.html#a8ff3abdbfa9aec3a0c2cb6326f0857c7">onStoreStart</a>(std::string fileName) <span class="keyword">override</span>;            <span class="comment">// Called for a STOR request.</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordtype">size_t</span>      <a class="code" href="classFTPFileCallbacks.html#aac5fb14e31fa780430e0686b14589f8d">onStoreData</a>(uint8_t* data, <span class="keywordtype">size_t</span> size) <span class="keyword">override</span>;       <span class="comment">// Called when a chunk of STOR data becomes available.</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classFTPFileCallbacks.html#a774689d1eec3358d7258684d6df0e863">onStoreEnd</a>() <span class="keyword">override</span>;                                  <span class="comment">// Called at the end of a STOR request.</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classFTPFileCallbacks.html#a75e9f0177e3d66f0d07e875d755dac7e">onRetrieveStart</a>(std::string fileName) <span class="keyword">override</span>;         <span class="comment">// Called at the start of a RETR request.</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">size_t</span>      <a class="code" href="classFTPFileCallbacks.html#a541964c7f8f736dc156b94c0e80dcfba">onRetrieveData</a>(uint8_t* data, <span class="keywordtype">size_t</span> size) <span class="keyword">override</span>;    <span class="comment">// Called to retrieve a chunk of RETR data.</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span>        <a class="code" href="classFTPFileCallbacks.html#ae6ba0c51e599e963d1584a0a46287f1f">onRetrieveEnd</a>() <span class="keyword">override</span>;                               <span class="comment">// Called when we have retrieved all the data.</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    std::string <a class="code" href="classFTPFileCallbacks.html#a9694f9a616a82f44af6be0fd9eb90df3">onDir</a>() <span class="keyword">override</span>;                                       <span class="comment">// Called to retrieve all the directory entries.</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    std::ofstream m_storeFile;    <span class="comment">// File used to store data from the client.</span></div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    std::ifstream m_retrieveFile;   <span class="comment">// File used to retrieve data for the client.</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    uint32_t      m_byteCount;    <span class="comment">// Count of bytes sent over wire.</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;};</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classFTPServer.html">   51</a></span>&#160;<span class="keyword">class </span><a class="code" href="classFTPServer.html">FTPServer</a> {</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <a class="code" href="classFTPServer.html">FTPServer</a>();</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classFTPServer.html">FTPServer</a>();</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">void</span> setCredentials(std::string userid, std::string password);</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFTPServer.html#a84264700de3f7a384a885977145ba9c0">start</a>();</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFTPServer.html#adee541fc29714c9ff5f478892b0efe60">setPort</a>(uint16_t port);</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classFTPServer.html#a193be61985bf88aa0cc70834a801916a">setCallbacks</a>(<a class="code" href="classFTPCallbacks.html">FTPCallbacks</a>* pFTPCallbacks);</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keyword">static</span> std::string <a class="code" href="classFTPServer.html#a89b431ba6aab76fc1da8f9aa3a4c3cc6">getCurrentDirectory</a>();</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classFTPServer_1_1FileException.html">   60</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classFTPServer_1_1FileException.html">FileException</a>: <span class="keyword">public</span> std::exception {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    };</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="comment">// Response codes.</span></div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_150_ABOUT_TO_OPEN_DATA_CONNECTION = 150;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_200_COMMAND_OK                    = 200;</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_202_COMMAND_NOT_IMPLEMENTED      = 202;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_212_DIRECTORY_STATUS            = 212;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_213_FILE_STATUS                  = 213;</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_214_HELP_MESSAGE                = 214;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_220_SERVICE_READY              = 220;</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_221_CLOSING_CONTROL_CONNECTION    = 221;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_230_USER_LOGGED_IN                = 230;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_226_CLOSING_DATA_CONNECTION      = 226;</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_227_ENTERING_PASSIVE_MODE      = 227;</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_331_PASSWORD_REQUIRED          = 331;</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_332_NEED_ACCOUNT                = 332;</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_500_COMMAND_UNRECOGNIZED        = 500;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_502_COMMAND_NOT_IMPLEMENTED      = 502;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_503_BAD_SEQUENCE                = 503;</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_530_NOT_LOGGED_IN              = 530;</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_550_ACTION_NOT_TAKEN            = 550;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">int</span> RESPONSE_553_FILE_NAME_NOT_ALLOWED      = 553;</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="keywordtype">int</span>         m_serverSocket;   <span class="comment">// The socket the FTP server is listening on.</span></div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordtype">int</span>         m_clientSocket;   <span class="comment">// The current client socket.</span></div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <span class="keywordtype">int</span>         m_dataSocket;     <span class="comment">// The data socket.</span></div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">int</span>         m_passiveSocket;  <span class="comment">// The socket on which the server is listening for passive FTP connections.</span></div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    uint16_t    m_port;           <span class="comment">// The port the FTP server will use.</span></div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    uint16_t    m_dataPort;       <span class="comment">// The port for data connections.</span></div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    uint32_t    m_dataIp;         <span class="comment">// The ip address for data connections.</span></div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">bool</span>        m_isPassive;      <span class="comment">// Are we in passive mode?  If not, then we are in active mode.</span></div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <span class="keywordtype">bool</span>        m_isImage;        <span class="comment">// Are we in image mode?</span></div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordtype">size_t</span>      m_chunkSize;      <span class="comment">// The maximum chunk size.</span></div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    std::string m_userid;         <span class="comment">// The required userid.</span></div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    std::string m_password;       <span class="comment">// The required password.</span></div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    std::string m_suppliedUserid; <span class="comment">// The userid supplied from the USER command.</span></div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <span class="keywordtype">bool</span>        m_loginRequired;  <span class="comment">// Do we required a login?</span></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <span class="keywordtype">bool</span>        m_isAuthenticated;  <span class="comment">// Have we authenticated?</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    std::string m_lastCommand;    <span class="comment">// The last command that was processed.</span></div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <a class="code" href="classFTPCallbacks.html">FTPCallbacks</a>*    m_callbacks;  <span class="comment">// The callbacks for processing.</span></div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="keywordtype">void</span> closeConnection();</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keywordtype">void</span> closeData();</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="keywordtype">void</span> closePassive();</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keywordtype">void</span> onAuth(std::istringstream&amp; ss);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keywordtype">void</span> onCwd(std::istringstream&amp; ss);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keywordtype">void</span> onList(std::istringstream&amp; ss);</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <span class="keywordtype">void</span> onMkd(std::istringstream&amp; ss);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="keywordtype">void</span> onNoop(std::istringstream&amp; ss);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keywordtype">void</span> onPass(std::istringstream&amp; ss);</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordtype">void</span> onPasv(std::istringstream&amp; ss);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="keywordtype">void</span> onPort(std::istringstream&amp; ss);</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="keywordtype">void</span> onPWD(std::istringstream&amp; ss);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordtype">void</span> onQuit(std::istringstream&amp; ss);</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keywordtype">void</span> onRetr(std::istringstream&amp; ss);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordtype">void</span> onRmd(std::istringstream&amp; ss);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <span class="keywordtype">void</span> onStor(std::istringstream&amp; ss);</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordtype">void</span> onSyst(std::istringstream&amp; ss);</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="keywordtype">void</span> onType(std::istringstream&amp; ss);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordtype">void</span> onUser(std::istringstream&amp; ss);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keywordtype">void</span> onXmkd(std::istringstream&amp; ss);</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordtype">void</span> onXrmd(std::istringstream&amp; ss);</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <span class="keywordtype">bool</span> openData();</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keywordtype">void</span> receiveFile(std::string fileName);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordtype">void</span> sendResponse(<span class="keywordtype">int</span> code);</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <span class="keywordtype">void</span> sendResponse(<span class="keywordtype">int</span> code, std::string text);</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="keywordtype">void</span> sendData(uint8_t* pData, uint32_t size);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    std::string listenPassive();</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keywordtype">int</span> waitForFTPClient();</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordtype">void</span> processCommand();</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;};</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* NETWORKING_FTPSERVER_FTPSERVER_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classFTPServer_html"><div class="ttname"><a href="classFTPServer.html">FTPServer</a></div><div class="ttdef"><b>Definition:</b> FTPServer.h:51</div></div>
<div class="ttc" id="classFTPServer_1_1FileException_html"><div class="ttname"><a href="classFTPServer_1_1FileException.html">FTPServer::FileException</a></div><div class="ttdef"><b>Definition:</b> FTPServer.h:60</div></div>
<div class="ttc" id="classFTPFileCallbacks_html"><div class="ttname"><a href="classFTPFileCallbacks.html">FTPFileCallbacks</a></div><div class="ttdef"><b>Definition:</b> FTPServer.h:33</div></div>
<div class="ttc" id="classFTPCallbacks_html_a310e8643ffeec67b4049423c44ba1b23"><div class="ttname"><a href="classFTPCallbacks.html#a310e8643ffeec67b4049423c44ba1b23">FTPCallbacks::onStoreStart</a></div><div class="ttdeci">virtual void onStoreStart(std::string fileName)</div><div class="ttdoc">-— END OF FTPFileCallbacks</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:106</div></div>
<div class="ttc" id="classFTPServer_html_a89b431ba6aab76fc1da8f9aa3a4c3cc6"><div class="ttname"><a href="classFTPServer.html#a89b431ba6aab76fc1da8f9aa3a4c3cc6">FTPServer::getCurrentDirectory</a></div><div class="ttdeci">static std::string getCurrentDirectory()</div><div class="ttdef"><b>Definition:</b> FTPServer.cpp:110</div></div>
<div class="ttc" id="classFTPServer_html_a193be61985bf88aa0cc70834a801916a"><div class="ttname"><a href="classFTPServer.html#a193be61985bf88aa0cc70834a801916a">FTPServer::setCallbacks</a></div><div class="ttdeci">void setCallbacks(FTPCallbacks *pFTPCallbacks)</div><div class="ttdef"><b>Definition:</b> FTPServer.cpp:728</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_a774689d1eec3358d7258684d6df0e863"><div class="ttname"><a href="classFTPFileCallbacks.html#a774689d1eec3358d7258684d6df0e863">FTPFileCallbacks::onStoreEnd</a></div><div class="ttdeci">void onStoreEnd() override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:37</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_a8ff3abdbfa9aec3a0c2cb6326f0857c7"><div class="ttname"><a href="classFTPFileCallbacks.html#a8ff3abdbfa9aec3a0c2cb6326f0857c7">FTPFileCallbacks::onStoreStart</a></div><div class="ttdeci">void onStoreStart(std::string fileName) override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:12</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_ae6ba0c51e599e963d1584a0a46287f1f"><div class="ttname"><a href="classFTPFileCallbacks.html#ae6ba0c51e599e963d1584a0a46287f1f">FTPFileCallbacks::onRetrieveEnd</a></div><div class="ttdeci">void onRetrieveEnd() override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:79</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_aac5fb14e31fa780430e0686b14589f8d"><div class="ttname"><a href="classFTPFileCallbacks.html#aac5fb14e31fa780430e0686b14589f8d">FTPFileCallbacks::onStoreData</a></div><div class="ttdeci">size_t onStoreData(uint8_t *data, size_t size) override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:25</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_a541964c7f8f736dc156b94c0e80dcfba"><div class="ttname"><a href="classFTPFileCallbacks.html#a541964c7f8f736dc156b94c0e80dcfba">FTPFileCallbacks::onRetrieveData</a></div><div class="ttdeci">size_t onRetrieveData(uint8_t *data, size_t size) override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:66</div></div>
<div class="ttc" id="classFTPCallbacks_html"><div class="ttname"><a href="classFTPCallbacks.html">FTPCallbacks</a></div><div class="ttdef"><b>Definition:</b> FTPServer.h:17</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_a75e9f0177e3d66f0d07e875d755dac7e"><div class="ttname"><a href="classFTPFileCallbacks.html#a75e9f0177e3d66f0d07e875d755dac7e">FTPFileCallbacks::onRetrieveStart</a></div><div class="ttdeci">void onRetrieveStart(std::string fileName) override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:47</div></div>
<div class="ttc" id="classFTPFileCallbacks_html_a9694f9a616a82f44af6be0fd9eb90df3"><div class="ttname"><a href="classFTPFileCallbacks.html#a9694f9a616a82f44af6be0fd9eb90df3">FTPFileCallbacks::onDir</a></div><div class="ttdeci">std::string onDir() override</div><div class="ttdef"><b>Definition:</b> FTPCallbacks.cpp:90</div></div>
<div class="ttc" id="classFTPServer_html_adee541fc29714c9ff5f478892b0efe60"><div class="ttname"><a href="classFTPServer.html#adee541fc29714c9ff5f478892b0efe60">FTPServer::setPort</a></div><div class="ttdeci">void setPort(uint16_t port)</div><div class="ttdef"><b>Definition:</b> FTPServer.cpp:745</div></div>
<div class="ttc" id="classFTPServer_html_a84264700de3f7a384a885977145ba9c0"><div class="ttname"><a href="classFTPServer.html#a84264700de3f7a384a885977145ba9c0">FTPServer::start</a></div><div class="ttdeci">void start()</div><div class="ttdef"><b>Definition:</b> FTPServer.cpp:753</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
